package ru.landgrafhomyak.db.skeleton1.api.table

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.DatabaseType
import ru.landgrafhomyak.db.skeleton1.api.ObjectOperations
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow


public interface TableConstructorScope<tUE : Any, IK : Any> {
	public fun <RT> column(name: String, type: DatabaseType.ImplementationsProvider<RT>): Column<RT, tUE, IK>

	public fun <RT> column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: _Statement.Void2Void<*, IK>
	): Column<RT, tUE, IK>
	public fun <RT> column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: RawStatement.Void2Void.ImplementationsProvider<*>
	): Column<RT, tUE, IK>

	@LowLevelApi
	public fun <RT, sUE : Any> _column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: _Statement.Void2Void<sUE, IK>
	): InputRow._Scope<sUE, IK, Column<RT, tUE, IK>>

	@LowLevelApi
	public fun <RT, sUE : Any> _column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: RawStatement.Params2Void.ImplementationsProvider<sUE>
	): InputRow._Scope<sUE, IK, Column<RT, tUE, IK>>

	public fun <oUE : Any?> tableScopedObject(name: String, metadata: ObjectOperations.ImplementationsProvider<oUE>): TableScopedObject<oUE, tUE, IK>

	public fun addAlterStatement(stmt: _Statement.Void2Void<*, IK>)
	public fun addAlterStatement(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatement(stmt: _Statement.Void2Void<sUE, IK>): InputRow._Scope<sUE, IK, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatement(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, IK, Unit>
}